diff -r 1d1c4c997b66 sys/netinet/mptcp_reass.c
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/sys/netinet/mptcp_reass.c	Sun Aug 30 14:27:42 2015 +1000
@@ -0,0 +1,262 @@
+/*-
+ * Copyright (c) 2013-2015
+ * Swinburne University of Technology, Melbourne, Australia.
+ * All rights reserved.
+ *
+ * This software was developed at the Centre for Advanced Internet
+ * Architectures, Swinburne University of Technology, by Nigel Williams,
+ * made possible in part by a gift from the FreeBSD Foundation and The
+ * Cisco University Research Program Fund, a corporate advised fund of
+ * Silicon Valley Community Foundation.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include "opt_compat.h"
+#include "opt_inet.h"
+#include "opt_inet6.h"
+#include "opt_ipsec.h"
+#include "opt_tcpdebug.h"
+
+#include <sys/malloc.h>
+#include <sys/mbuf.h>
+#include <sys/param.h>
+#include <sys/queue.h>
+#include <sys/systm.h>
+#include <sys/callout.h>
+#include <sys/hhook.h>
+#include <sys/kernel.h>
+#include <sys/khelp.h>
+#include <sys/kdb.h>
+#include <sys/lock.h>
+#include <sys/rwlock.h>
+#include <sys/sysctl.h>
+#include <sys/sbuf.h>
+#include <sys/taskqueue.h>
+#include <sys/jail.h>
+
+#ifdef INET6
+#include <sys/domain.h>
+#endif
+#include <sys/priv.h>
+#include <sys/proc.h>
+#include <sys/protosw.h>
+#include <sys/refcount.h>
+#include <sys/sockbuf.h>
+#include <sys/socket.h>
+#include <sys/socketvar.h>
+#include <sys/protosw.h>
+#include <sys/random.h>
+
+#include <netinet/in.h>
+#include <netinet/in_pcb.h>
+#include <netinet/tcp_var.h>
+#include <netinet/tcp_timer.h>
+#include <netinet/tcp_usrreq.h>
+#include <netinet/tcp_fsm.h>
+#include <netinet/tcp_seq.h>
+#include <netinet/tcp_syncache.h>
+
+#include <netinet/mptcp.h>
+#include <netinet/mptcp_timer.h>
+#include <netinet/mptcp_var.h>
+#include <netinet/mptcp_pcb.h>
+
+#include <machine/in_cksum.h>
+#include <machine/stdarg.h>
+
+
+
+int
+mp_reass(struct mpcb *mp, struct mbuf *m)
+{
+	struct mbuf *mq, *mpre;
+	struct socket *so = mp->mp_mppcb->mpp_socket;
+	int flags = 0, wakeup = 0, todrop;
+
+	MPP_LOCK_ASSERT(mp->mp_mppcb);
+
+	M_ASSERTPKTHDR(m);
+    KASSERT(m_tag_locate(m, PACKET_COOKIE_MPTCP, PACKET_TAG_DSN, NULL) != NULL,
+        ("%s: no dsn tag on segment\n", __func__));
+
+//	printf("%s: packetlen %d\n", __func__, m->m_pkthdr.len);
+//    printf("%s: ds_rcv_nxt: %u mdsn %u\n", __func__,
+//        (uint32_t) mp->ds_rcv_nxt, (uint32_t) M_MPTCPDSN(m));
+//    printf("%s: ds_rcv_nxt: %ju mdsn %ju\n", __func__,
+//		mp->ds_rcv_nxt, M_MPTCPDSN(m));
+    if (M_MPTCPDSNFLAGS(m) & MP_DFIN)
+		printf("%s: inserting dfin seg %u ds_rcv_nxt: %u\n",__func__,
+		    (uint32_t) mp->ds_rcv_nxt, (uint32_t) M_MPTCPDSN(m));
+
+    /* Trim overlapping at data level, or drop if duplicate */
+    todrop = mp->ds_rcv_nxt - M_MPTCPDSN(m);
+    if (todrop > 0) {
+//    	printf("%s: dup segment %u len %d todrop %d \n", __func__,
+//    		(uint32_t) M_MPTCPDSN(m), m->m_pkthdr.len, todrop);
+    	/* Partially duplicated segment. Trim until
+		 * we reach the new data. Otherwise a complete
+		 * duplicate that can be freed. goto present
+		 * to read in any queued data. */
+    	if (todrop < m->m_pkthdr.len) {
+			M_MPTCPDSN(m) += todrop;
+			m_adj(m, todrop);
+		} else {
+			m_freem(m);
+			if (mp->mp_segq)
+			    goto present;
+			else
+				return (0);
+		}
+    }
+
+	/*
+	 * Find a segment which begins after this one does.
+     * XXX: adjust for dealing with DSNs
+	 */
+	mpre = NULL;
+	for (mq = mp->mp_segq; mq != NULL; mq = mq->m_nextpkt) {
+//		printf("%s: mqdsn %lu mdsn %lu\n", __func__,
+//		    M_MPTCPDSN(mq), M_MPTCPDSN(m));
+		if (DSEQ_GT((uint64_t)M_MPTCPDSN(mq), (uint64_t)M_MPTCPDSN(m)))
+			break;
+		mpre = mq;
+//		printf("%s: mpre set, dsn %u\n", __func__, (uint32_t) M_MPTCPDSN(mq));
+	}
+
+	/*
+	 * If there is a preceding segment, it may provide some of
+	 * our data already.  If so, drop the data from the incoming
+	 * segment.  If it provides all of our data, drop us.
+     *
+     * XXX: in this case dealing with DSNs rather than TCP SEQs.
+     * So previous_dsn + previous_len compared with the DSN on
+     * the passed in mbuf.
+     *
+     * After adjustment we change the DSN on the mbuf tag. Note
+     * that the
+	 */
+	if (mpre != NULL) {
+		int i;
+
+		/* conversion to int (in i) handles seq wraparound */
+		i = M_MPTCPDSN(mpre) + mpre->m_pkthdr.len - M_MPTCPDSN(m);
+		if (i > 0) {
+			if (i >= m->m_pkthdr.len) {
+				m_freem(m);
+				/*
+				 * Try to present any queued data
+				 * at the left window edge to the user.
+				 * This is needed after the 3-WHS
+				 * completes.
+				 */
+				goto present;	/* ??? */
+			}
+			m_adj(m, i);
+			M_MPTCPDSN(m) += i;
+		}
+	}
+
+	/*
+	 * While we overlap succeeding segments trim them or,
+	 * if they are completely covered, dequeue them.
+	 */
+	while (mq) {
+		struct mbuf *nq;
+		int i;
+
+		i = (M_MPTCPDSN(m) + m->m_pkthdr.len) - M_MPTCPDSN(mq);
+		if (i <= 0)
+			break;
+		if (i < mq->m_pkthdr.len) {
+			M_MPTCPDSN(mq) += i;
+			m_adj(mq, i);
+			mp->mp_segqlen -= i;
+			break;
+		}
+
+		nq = mq->m_nextpkt;
+		mp->mp_segqlen -= mq->m_pkthdr.len;
+		m_freem(mq);
+		if (mpre)
+			mpre->m_nextpkt = nq;
+		else
+			mp->mp_segq = nq;
+		mq = nq;
+	}
+
+	/*
+	 * Insert the new (data-level) segment queue entry into place.
+	 */
+	if (mpre) {
+		m->m_nextpkt = mpre->m_nextpkt;
+		mpre->m_nextpkt = m;
+	} else {
+		mq = mp->mp_segq;
+		mp->mp_segq = m;
+		m->m_nextpkt = mq;
+	}
+	mp->mp_segqlen += m->m_pkthdr.len;
+
+present:
+
+    /* XXXNJW: check to see if first segment is in order.
+     * if so, schedule mp_input, which will append the
+     * data to the buffer. */
+	mq = mp->mp_segq;
+//    printf("%s: present, got %ju, rcv_nxt %ju\n", __func__,
+//		M_MPTCPDSN(mq), mp->ds_rcv_nxt);
+
+	SOCKBUF_LOCK(&so->so_rcv);
+	while ((mq = mp->mp_segq) != NULL &&
+		M_MPTCPDSN(mq) == mp->ds_rcv_nxt) {
+
+		mp->mp_segq = mq->m_nextpkt;
+		mp->ds_rcv_nxt += mq->m_pkthdr.len;
+		mp->mp_segqlen -= mq->m_pkthdr.len;
+
+//		printf("%s: rcv_nst now %ju\n", __func__, mp->ds_rcv_nxt);
+
+		/* XXXNJW: temp way to handle receipt of DFIN. Need to +1
+		 * ds_rcv_nxt as generally it is increased by segment length
+		 * rather than the dss_len (also currently the dss len isn't
+		 * included in the mtag) */
+		flags = M_MPTCPDSNFLAGS(mq) & MP_DFIN;
+
+		if (so->so_rcv.sb_state & SBS_CANTRCVMORE)
+			m_freem(mq);
+		else {
+			mq->m_nextpkt = NULL;
+			sbappendstream_locked(&so->so_rcv, mq, 0);
+			wakeup = 1;
+		}
+	}
+
+	if (wakeup) {
+		mp->mp_flags |= MPF_ACKNOW;
+		sorwakeup_locked(so);
+	} else
+		SOCKBUF_UNLOCK(&so->so_rcv);
+
+	return (flags);
+
+}
diff -r 1d1c4c997b66 sys/netinet/mptcp_sched.h
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/sys/netinet/mptcp_sched.h	Sun Aug 30 14:27:42 2015 +1000
@@ -0,0 +1,118 @@
+/*-
+ * Copyright (c) 2013-2015
+ * Swinburne University of Technology, Melbourne, Australia.
+ * All rights reserved.
+ *
+ * This software was developed at the Centre for Advanced Internet
+ * Architectures, Swinburne University of Technology, by Nigel Williams,
+ * made possible in part by a gift from the FreeBSD Foundation and The
+ * Cisco University Research Program Fund, a corporate advised fund of
+ * Silicon Valley Community Foundation.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef MPTCP_SCHED_H_
+#define MPTCP_SCHED_H_
+
+#include <netinet/tcp.h>
+#include <netinet/mptcp_var.h>
+
+/* Global scheduler vars. */
+extern STAILQ_HEAD(sched_head, sched_algo) sched_list;
+extern struct sched_disc roundrobin_sched_algo;
+
+/* Per-netstack bits. */
+VNET_DECLARE(struct sched_algo *, default_sched_ptr);
+#define	V_default_sched_ptr VNET(default_sched_ptr)
+
+/* Define the new net.inet.tcp.mptcp.sched sysctl tree. */
+SYSCTL_DECL(_net_inet_tcp_mptcp_sched);
+
+/* Scheduler housekeeping functions. */
+int	sched_register_algo(struct sched_algo *add_sched_algo);
+int	sched_deregister_algo(struct sched_algo *remove_sched_algo);
+
+/*
+ * Struct holding data to be passed from the tcpcb to the scheduling algorithm
+ */
+struct sched_var {
+	void        *sched_data; /* Per-connection private sched algorithm data. */
+	uint32_t    flags; /* Flags for sched_var (see below) */
+	struct mpcb *mp;
+	struct tcpcb *tcp; /* TCP control block of calling subflow */
+	struct tcpcb *sched_tp; /* The pcb selected by algorithm */
+};
+
+/* sched_var flags */
+// Any flags relevant to _all_ schedulers should be defined here
+
+/*
+ * Structure to hold data and function pointers that together represent a
+ * packet scheduling discipline.
+ */
+struct sched_algo {
+	char	name[MPTCP_SA_NAME_MAX];
+
+	/* Init global module state on kldload. */
+	int	(*mod_init)(void);
+
+	/* Cleanup global module state on kldunload. */
+	int	(*mod_destroy)(void);
+
+	/* Init scheduler state for a new control block. */
+	int	(*cb_init)(struct sched_var *sched);
+
+	/* Cleanup scheduler state for a terminating control block. */
+	void	(*cb_destroy)(struct sched_var *sv);
+
+	/* Init variables for a newly established connection. */
+	void	(*conn_init)(struct sched_var *sv);
+
+	/* Called on writing new data to socket buffer (tcp_usr_send) */
+	void	(*sched_usr_send)(struct sched_var *sv, uint16_t type);
+
+	/* Called on execution of scheduler task */
+	void	(*sched_task)(struct sched_var *sv, uint16_t type);
+
+	STAILQ_ENTRY (sched_algo) entries;
+};
+
+/* Macro to obtain the sched algo's struct ptr. */
+#define	SCHED_ALGO(mp)	((mp)->sched_algo)
+
+/* Macro to obtain the sched algo's data ptr. */
+#define	SCHED_DATA(mp)	((mp)->sched_v->sched_data)
+
+/* Macro to obtain the system default Scheduler algo's struct ptr. */
+#define	SCHED_DEFAULT() V_default_sched_ptr
+
+extern struct rwlock sched_list_lock;
+#define	SCHED_LIST_LOCK_INIT()	    rw_init(&sched_list_lock, "sched_list")
+#define	SCHED_LIST_LOCK_DESTROY()	rw_destroy(&sched_list_lock)
+#define	SCHED_LIST_RLOCK()		    rw_rlock(&sched_list_lock)
+#define	SCHED_LIST_RUNLOCK()	    rw_runlock(&sched_list_lock)
+#define	SCHED_LIST_WLOCK()		    rw_wlock(&sched_list_lock)
+#define	SCHED_LIST_WUNLOCK()	    rw_wunlock(&sched_list_lock)
+#define	SCHED_LIST_LOCK_ASSERT()	rw_assert(&sched_list_lock, RA_LOCKED)
+
+#endif /* MPTCP_SCHED_H_ */
diff -r 1d1c4c997b66 sys/netinet/mptcp_timer.c
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/sys/netinet/mptcp_timer.c	Sun Aug 30 14:27:42 2015 +1000
@@ -0,0 +1,249 @@
+/*-
+ * Copyright (c) 2013-2015
+ * Swinburne University of Technology, Melbourne, Australia.
+ * All rights reserved.
+ *
+ * This software was developed at the Centre for Advanced Internet
+ * Architectures, Swinburne University of Technology, by Nigel Williams,
+ * made possible in part by a gift from the FreeBSD Foundation and The
+ * Cisco University Research Program Fund, a corporate advised fund of
+ * Silicon Valley Community Foundation.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD$");
+
+#include "opt_compat.h"
+#include "opt_inet.h"
+#include "opt_inet6.h"
+#include "opt_ipsec.h"
+#include "opt_tcpdebug.h"
+
+#include <sys/malloc.h>
+#include <sys/mbuf.h>
+#include <sys/param.h>
+#include <sys/systm.h>
+#include <sys/kernel.h>
+#include <sys/lock.h>
+#include <sys/rwlock.h>
+#include <sys/sysctl.h>
+#include <sys/sbuf.h>
+#include <sys/jail.h>
+
+#include <sys/priv.h>
+#include <sys/proc.h>
+#include <sys/protosw.h>
+
+/* XXXNJW: too many header dependencies with mptcp_var.h? (i.e. need to pull in
+ * in.h etc etc to compile. */
+#include <netinet/in.h>
+
+#include <sys/sockbuf.h>
+#include <sys/socket.h>
+#include <sys/socketvar.h>
+
+#include <net/vnet.h>
+#include <netinet/in_pcb.h>
+#include <netinet/tcp_var.h>
+#include <netinet/mptcp_pcb.h>
+#include <netinet/mptcp_var.h>
+#include <netinet/mptcp_timer.h>
+
+
+int	mp_backoff[MPT_MAXRXTSHIFT + 1] = {1, 1, 1, 1};
+
+
+void
+mp_timer_activate(struct mpcb *mp, int timer_type, u_int delta)
+{
+	struct callout *t_callout;
+	void *f_callout;
+	int cpu = curcpu;   /* XXNJW: look into cpuid stuff */
+
+	MPP_LOCK_ASSERT(mp->mp_mppcb);
+
+	switch (timer_type) {
+		case MPT_REXMT:
+			t_callout = &mp->mp_timers->mpt_rexmt;
+			f_callout = mp_timer_rexmt;
+			break;
+		case MPT_TIMEOUT:
+			printf("%s: mp %p activate timeout\n", __func__, mp);
+			t_callout = &mp->mp_timers->mpt_timeout;
+			f_callout = mp_timer_timeout;
+			break;
+		default:
+			panic("bad timer_type");
+		}
+	if (delta == 0) {
+		callout_stop(t_callout);
+	} else {
+		callout_reset_on(t_callout, delta, f_callout, mp, cpu);
+	}
+}
+
+int
+mp_timer_active(struct mpcb *mp, int timer_type)
+{
+	struct callout *t_callout;
+
+	MPP_LOCK_ASSERT(mp->mp_mppcb);
+
+	switch (timer_type) {
+	    case MPT_REXMT:
+		    t_callout = &mp->mp_timers->mpt_rexmt;
+		    break;
+		case MPT_TIMEOUT:
+			t_callout = &mp->mp_timers->mpt_timeout;
+			break;
+		default:
+			panic("bad timer_type");
+		}
+	return callout_active(t_callout);
+}
+
+void
+mp_timer_rexmt(void * xmp)
+{
+    struct mppcb *mpp;
+    struct mpcb *mp = xmp;
+
+    /* XXXNJW should be concerned about races with discard? */
+	if (mp == NULL) {
+		CURVNET_RESTORE();
+		return;
+	}
+
+	mpp = mp->mp_mppcb;
+    MPP_LOCK(mpp);
+
+	printf("%s: rxtshift %d, snd_nxt %u snd_una %u\n", __func__,
+	    mp->mp_rxtshift, (uint32_t) mp->ds_snd_nxt,
+	    (uint32_t) mp->ds_snd_una);
+
+	if (callout_pending(&mp->mp_timers->mpt_rexmt) ||
+		!callout_active(&mp->mp_timers->mpt_rexmt))
+        goto out;
+
+	callout_deactivate(&mp->mp_timers->mpt_rexmt);
+	if ((mpp->mpp_flags & MPP_DROPPED) != 0)
+		goto out;
+
+    /* Reached max data-level RTOs, drop the connection. */
+	if (++mp->mp_rxtshift > MPT_MAXRXTSHIFT) {
+		printf("%s: rxtshift %d reset subflows\n", __func__, mp->mp_rxtshift);
+		mp->mp_rxtshift = MPT_MAXRXTSHIFT;
+		mp_reset_all_subflows(mp);
+		(void) mp_drop(mp, ETIMEDOUT);
+		KASSERT(mp != NULL, ("%s: MP is NULL\n", __func__));
+		goto out;
+	}
+
+    /* update the timer */
+    mp->mp_rxtcur = MPTCPTV_RTOBASE * mp_backoff[mp->mp_rxtshift];
+    mp->ds_snd_nxt = mp->ds_snd_una;
+
+    printf("%s: mp_rxtcur %d ticks\n", __func__, mp->mp_rxtcur);
+
+    (void) mp_output(mp);
+
+    // mp_output now returns locked
+//    CURVNET_RESTORE();
+//    return;
+
+out:
+    MPP_UNLOCK(mpp);
+	CURVNET_RESTORE();
+}
+
+
+/* XXXNJW: timeout only set when we have no subflows (i.e.
+ * all have detached.) Thus in this case we can call mp_close
+ * */
+void
+mp_timer_timeout(void * xmp)
+{
+    struct mppcb *mpp;
+    struct mpcb *mp = xmp;
+    struct socket *so;
+
+    printf("%s: mp %p\n", __func__, mp);
+
+    /* XXXNJW should be concerned about races with discard? */
+    if (mp == NULL) {
+		CURVNET_RESTORE();
+		return;
+	}
+
+    mpp = mp->mp_mppcb;
+    MPP_LOCK(mpp);
+
+	if (callout_pending(&mp->mp_timers->mpt_timeout) ||
+		!callout_active(&mp->mp_timers->mpt_timeout))
+        goto out;
+
+	callout_deactivate(&mp->mp_timers->mpt_timeout);
+
+	mpp_pcbdrop(mpp);
+
+	/* Arrive here at end of timewait, or timed out. */
+	if (mpp->mpp_flags & MPP_TIMEWAIT) {
+		/* XXXNJW: what if we still have subflow cnt > 0 at this point? */
+		mp->mp_state = MPS_M_CLOSED;
+		so = mpp->mpp_socket;
+		if (so != NULL) {
+			/* XXXNJW: expect to have socket reference if the socket
+			 * still exists at the end of timewait. */
+			if (mpp->mpp_flags & MPP_SOCKREF) {
+				mpp->mpp_flags &= ~MPP_SOCKREF;
+				MPP_UNLOCK(mpp);
+				ACCEPT_LOCK();
+				SOCK_LOCK(so);
+				KASSERT(so->so_state & SS_PROTOREF,
+					("tcp_twclose: INP_SOCKREF && !SS_PROTOREF"));
+				so->so_state &= ~SS_PROTOREF;
+				sofree(so);
+				return;
+			} else {
+				/* should not be any cases where something else has a
+				 * reference to the socket? */
+				printf("%s: ended timewait with socket, no hard ref\n",
+				    __func__);
+			}
+		} else {
+			/* The socket has been already cleaned-up for us, free mp, mpp */
+			mp_discardcb(mp);
+			mp = NULL;
+			mpp_pcbfree(mpp);
+			mpp = NULL;
+		}
+	} else {
+		mp = mp_drop(mp, ETIMEDOUT);
+	}
+out:
+    if (mp != NULL)
+	    MPP_UNLOCK(mpp);
+	CURVNET_RESTORE();
+}
diff -r 1d1c4c997b66 sys/netinet/mptcp_timer.h
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/sys/netinet/mptcp_timer.h	Sun Aug 30 14:27:42 2015 +1000
@@ -0,0 +1,58 @@
+/*-
+ * Copyright (c) 2013-2015
+ * Swinburne University of Technology, Melbourne, Australia.
+ * All rights reserved.
+ *
+ * This software was developed at the Centre for Advanced Internet
+ * Architectures, Swinburne University of Technology, by Nigel Williams,
+ * made possible in part by a gift from the FreeBSD Foundation and The
+ * Cisco University Research Program Fund, a corporate advised fund of
+ * Silicon Valley Community Foundation.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef MPTCP_TIMER_H_
+#define MPTCP_TIMER_H_
+
+#define	MPTCPTV_RTOBASE	(4*hz) /* Initial RTO length (arbitrary number) */
+#define MPTCPTV_TIMEOUT (30*hz) /* Once MPTCP session enters timewait */
+#define MPTCPTV_TIMEOUTCNT 2   /* Just a default multiplier for timeout */
+
+#define	MPT_MAXRXTSHIFT	3 /* Max retransmits (arbitrary number) */
+
+struct mpcb;
+
+struct mptcp_timer {
+	struct	callout mpt_rexmt;	    /* retransmit timer */
+	struct	callout mpt_timeout;   /* timewait */
+};
+#define MPT_REXMT    0x01
+#define MPT_TIMEOUT 0x02
+
+void	mp_timer_init(void);
+void    mp_timer_activate(struct mpcb *mp, int timer_type, u_int delta);
+int     mp_timer_active(struct mpcb *mp, int timer_type);
+void	mp_timer_rexmt(void *xmp);
+void	mp_timer_timeout(void *xmp);
+
+#endif /* MPTCP_TIMER_H_ */
diff -r 1d1c4c997b66 sys/netinet/mptcp_types.h
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/sys/netinet/mptcp_types.h	Sun Aug 30 14:27:42 2015 +1000
@@ -0,0 +1,42 @@
+/*-
+ * Copyright (c) 2012-2015
+ * Swinburne University of Technology, Melbourne, Australia.
+ * All rights reserved.
+ *
+ * This software was developed at the Centre for Advanced Internet
+ * Architectures, Swinburne University of Technology, by Nigel Williams,
+ * made possible in part by a gift from the FreeBSD Foundation and The
+ * Cisco University Research Program Fund, a corporate advised fund of
+ * Silicon Valley Community Foundation.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef MPTCP_TYPES_H_
+#define MPTCP_TYPES_H_
+
+struct multi_cb {
+	struct mpcb *mp;
+	struct inpcb *inp;
+};
+
+#endif /* MPTCP_TYPES_H_ */
